#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "vms_simple_stomp.h"

static void print(char *msg)
{
   printf("%s\n", msg);
}

static char *cstr(struct dsc$descriptor_s *s)
{
    int ix;
    char *res;
    res = malloc(s->dsc$w_length + 1);
    strncpy(res, s->dsc$a_pointer, s->dsc$w_length);
    res[s->dsc$w_length] = 0;
    /* trim traling spaces */
    ix = s->dsc$w_length - 1;
    while(ix >= 0 && res[ix] == ' ')
    {
        res[ix] = 0;
        ix--;
    }
    return res;
}

void vms_simple_stomp_debug(int *debug)
{
    simple_stomp_debug(*debug);
}


int vms_simple_stomp_init(simple_stomp_t *ctx, struct dsc$descriptor_s *host, int *port)
{
    int stat;
    char *host2;
    host2 = cstr(host);
    stat = simple_stomp_init(ctx, host2, *port, print);
    free(host2);
    return stat;
}

int vms_simple_stomp_write(simple_stomp_t *ctx, struct dsc$descriptor_s *qname, struct dsc$descriptor_s *msg)
{
    int stat;
    char *qname2, *msg2;
    qname2 = cstr(qname);
    msg2 = cstr(msg);
    stat = simple_stomp_write(ctx, qname2, msg2);
    free(qname2);
    free(msg2);
    return stat;
}

int vms_simple_stomp_read(simple_stomp_t *ctx, struct dsc$descriptor_s *qname, struct dsc$descriptor_s *msg, int *msglen)
{
    int stat;
    char *qname2;
    qname2 = cstr(qname);
    stat = simple_stomp_read(ctx, qname2, msg->dsc$a_pointer);
    *msglen = strlen(msg->dsc$a_pointer);
    free(qname2);
    return stat;
}

int vms_simple_stomp_close(simple_stomp_t *ctx)
{
    return simple_stomp_close(ctx);
}
